import java.io.*;
import java.util.*;
import javax.swing.*;

public class Utility
{
      public static void sleep(int ms)
      {
	 try 
	 {
	    Thread.currentThread().sleep(ms);
	 }
	 catch (InterruptedException ie)
	 {
	 }
      }

      public static Object[] shuffle(Object[] o)
      {
	 return selectRandomN(o.length, o);
      }
      /*      {
	 Object[] n = new Object[o.length];
	 for(int i = 0 ; i < o.length ; i++)
	 {
	    n[i] = null;
	    if (o[i] == null)
	       Utility.die("There should never be null objects in the sort list.");
	 }

	 for(int i = 0 ; i < o.length ; i++)
	 {
	    while(o[i] != null)
	    {
	       int t = (int)(Math.random() * n.length);
	       if (n[t] == null)
	       {
		  n[t] = o[i];
		  o[i] = null;
	       }
	    }
	 }
	 
	 return n;
	 }*/

      public static Object[] selectRandomN(int N, Object[] o)
      {
	 if(N > o.length)
	    N = o.length;

         Object[] n = new Object[N]; 
	 for(int i = 0 ; i < N ; i++)
	 {
	    while(n[i] == null)
	    {
	       int t = (int)(Math.random() * o.length);
	       if(o[t] != null)
	       {
		  n[i] = o[t];
		  o[t] = null;
	       }		     
	    }
	 }
	 return n;
      }

      public static Object[] makeArrayFromListModel(ListModel l)
      {
	 Object[] o = new Object[l.getSize()];
	 for(int i = 0 ; i < o.length ; i++)
	    o[i] = l.getElementAt(i);
	 return o;
      }

      // converts a \n separated string to a vector of strings
      public static Vector stringToVec(String s)
      {
	 Vector v = new Vector();
	 StringBuffer t = new StringBuffer(); 
	 for (int i = 0 ; i < s.length() ; i++) 
	 { 
	    if (s.charAt(i) == '\n') 
	    { 
	       v.add(t.toString()); 
	       t = new StringBuffer(); 
	    } 
	    else 
	       t.append(s.charAt(i)); 
	 }
	 return v;
      }

      public static void die(String s)
      {
	 System.err.println(s);
	 System.exit(3);
      }

      public static String configSet(Hashtable config, String key, String def)
      {
	 if (!config.containsKey(key))
	 {
	    System.out.println("Configuration key \"" + key + "\" left unset.  Setting " + key + "=" + def + ".");
	    return def;
	 }
	 else 
	    return (String)config.get(key);
      }


      public static Hashtable parseConfig(String fName)
      {
	 if(fName == null)
	    Utility.die("Filename given to parseConfig is null.");

	 BufferedReader br = null;
	 try
	 {
	    br = new BufferedReader(new InputStreamReader(new FileInputStream(fName)));
	 }
	 catch (java.io.FileNotFoundException fnfe)
	 {
	    Utility.die("Configuration file \"" + fName + "\" does not exist.");
	 }

	 Hashtable config = new Hashtable();
	 
	 String curline;
	 try
	 {
	    while( (curline = br.readLine()) != null)
	    {
	       // skip comments
	       if(curline.indexOf('#') != -1)
		  curline = curline.substring(0, curline.indexOf('#'));
	       curline = curline.trim();
	       
	       if (curline.length() > 0)
	       {
		  if(curline.indexOf(":") == -1)
		     Utility.die("Configuration item \"" + curline + "\" not in \"key : value\" form");
		  
		  String key = curline.substring(0,curline.indexOf(":")).trim().toLowerCase();
		  String value = curline.substring(curline.indexOf(":")+1,curline.length()).trim();
		  
		  config.put(key,value);
	       }	       
	    }
	 }
	 catch (java.io.IOException ioe)
	 {
	    Utility.die("Reading of config file interrupted.");
	 }

	 try
	 {
	    br.close();
	 }
	 catch(IOException ioe)
	 {
	    System.err.println("Couldn't close the configuration file");
	 }

	 return config;
      }
}